package edu.vub.at.simonsays;

import java.util.Vector;

import edu.vub.at.simonsays.interfaces.ButtonListener;

import android.content.Context;
import android.graphics.PorterDuff;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;

//   _________       _____  __                                  .____                                                               .____          ___.    
//  /   _____/ _____/ ____\/  |___  _  _______ _______   ____   |    |   _____    ____    ____  __ _______     ____   ____   ______ |    |   _____ \_ |__  
//  \_____  \ /  _ \   __\\   __\ \/ \/ /\__  \\_  __ \_/ __ \  |    |   \__  \  /    \  / ___\|  |  \__  \   / ___\_/ __ \ /  ___/ |    |   \__  \ | __ \ 
//  /        (  <_> )  |   |  |  \     /  / __ \|  | \/\  ___/  |    |___ / __ \|   |  \/ /_/  >  |  // __ \_/ /_/  >  ___/ \___ \  |    |___ / __ \| \_\ \
// /_______  /\____/|__|   |__|   \/\_/  (____  /__|    \___  > |_______ (____  /___|  /\___  /|____/(____  /\___  / \___  >____  > |_______ (____  /___  /
//        \/                                 \/            \/          \/    \/     \//_____/            \//_____/      \/     \/          \/    \/    \/ 
//
//  Distributed and Mobile Paradigms Course 
//  Lab Session 1

/*
 * Class implementing the model of a gridView.
 * It populates the gridview at runtime with 4 different buttons, one per each color that Simon says.
 */
public class ButtonAdapter extends BaseAdapter {

	private Context mContext;
	private Vector<Button> buttons = new Vector<Button>();
	//This constant should be derived from the screen height
	private static int HEIGHT = 300;
	
	public ButtonAdapter(Context c, final ButtonListener listener) {
		mContext = c;	   
		for (int i = 0; i < SimonActivity.simon_colors.length; i++) {
			final Button button = new Button(mContext);
			final int num = i;
	        button.setOnClickListener(new View.OnClickListener() {
	             public void onClick(View v) {
	            	 listener.buttonPressed(num);
	             }
	         });
			button.setHeight( HEIGHT );
			button.getBackground().setColorFilter(SimonActivity.simon_colors[i], PorterDuff.Mode.SCREEN);
			buttons.add(button);
		}
	}

	public int getCount() {
		return buttons.size();
	}

	public Object getItem(int position) {
		return buttons.elementAt(position);
	}

	public long getItemId(int position) {
		return 0;
	}

	// create a new ImageView for each item referenced by the Adapter
	public View getView(int position, View convertView, ViewGroup parent) {
		return buttons.elementAt(position);
	}


}
